/* Design by LAIHOYA at HIF Team                         
 *              08 07 06 05 04 03 02 01
 *                                   *
 * 74HC595  PIN 09 10 11 12 13 14 15 16
 *                    CK LT    DS
 *                    棕 白    紫
 * Arduino  PIN       6  5     7 
 *     
 */
// display array size
#define display_array_size 376
// how many led matrix do you 
#define led_matrix_number 8
// ascii 5x7 dot font
#define data_null 0x00, 0x00, 0x00 // null char
#define data_ascii_minus 0x08, 0x08, 0x08, 0x00 // -
#define data_ascii_dot 0x00, 0x60, 0x60, 0x00 // .
#define data_ascii_A 0x7C, 0x12, 0x11, 0x12, 0x7C, 0x00 // A 65
#define data_ascii_B 0x7F, 0x49, 0x49, 0x49, 0x36, 0x00 // B
#define data_ascii_C 0x3E, 0x41, 0x41, 0x41, 0x22, 0x00 // C
#define data_ascii_D 0x7F, 0x41, 0x41, 0x41, 0x3E, 0x00 // D
#define data_ascii_E 0x7F, 0x49, 0x49, 0x49, 0x41, 0x00 // E
#define data_ascii_F 0x7F, 0x09, 0x09, 0x09, 0x01, 0x00 // F 70
#define data_ascii_G 0x3E, 0x41, 0x41, 0x51, 0x73, 0x00 // G
#define data_ascii_H 0x7F, 0x08, 0x08, 0x08, 0x7F, 0x00 // H
#define data_ascii_I 0x00, 0x41, 0x7F, 0x41, 0x00, 0x00 // I
#define data_ascii_J 0x20, 0x40, 0x41, 0x3F, 0x01, 0x00 // J
#define data_ascii_K 0x7F, 0x08, 0x14, 0x22, 0x41, 0x00 // K 75
#define data_ascii_L 0x7F, 0x40, 0x40, 0x40, 0x40, 0x00 // L
#define data_ascii_M 0x7F, 0x02, 0x1C, 0x02, 0x7F, 0x00 // M
#define data_ascii_N 0x7F, 0x04, 0x08, 0x10, 0x7F, 0x00 // N
#define data_ascii_O 0x3E, 0x41, 0x41, 0x41, 0x3E, 0x00 // O
#define data_ascii_P 0x7F, 0x09, 0x09, 0x09, 0x06, 0x00 // P 80
#define data_ascii_Q 0x3E, 0x41, 0x51, 0x21, 0x5E, 0x00 // Q 81
#define data_ascii_R 0x7F, 0x09, 0x19, 0x29, 0x46, 0x00 // R 82
#define data_ascii_S 0x26, 0x49, 0x49, 0x49, 0x32, 0x00 // S 83
#define data_ascii_T 0x03, 0x01, 0x7F, 0x01, 0x03, 0x00 // T 84
#define data_ascii_U 0x3F, 0x40, 0x40, 0x40, 0x3F, 0x00 // U 85
#define data_ascii_V 0x1F, 0x20, 0x40, 0x20, 0x1F, 0x00 // V 86
#define data_ascii_W 0x3F, 0x40, 0x38, 0x40, 0x3F, 0x00 // W 87
#define data_ascii_X 0x63, 0x14, 0x08, 0x14, 0x63, 0x00 // Y 88
#define data_ascii_Y 0x03, 0x04, 0x78, 0x04, 0x03, 0x00 // X 89
#define data_ascii_Z 0x61, 0x59, 0x49, 0x4D, 0x43, 0x00 // Z 90
#define data_ascii_colon 0x00, 0x00, 0x14, 0x00, 0x00, 0x00 // : 58
#define data_ascii_47 {0x20, 0x10, 0x08, 0x04, 0x02, 0x00 // /
#define data_ascii_0 0x3E, 0x51, 0x49, 0x45, 0x3E, 0x00 // 0
#define data_ascii_1 0x00, 0x42, 0x7F, 0x40, 0x00, 0x00 // 1
#define data_ascii_2 0x72, 0x49, 0x49, 0x49, 0x46, 0x00 // 2
#define data_ascii_3 0x21, 0x41, 0x49, 0x4D, 0x33, 0x00 // 3
#define data_ascii_4 0x18, 0x14, 0x12, 0x7F, 0x10, 0x00 // 4
#define data_ascii_5 0x27, 0x45, 0x45, 0x45, 0x39, 0x00 // 5
#define data_ascii_6 0x3C, 0x4A, 0x49, 0x49, 0x31, 0x00 // 6
#define data_ascii_7 0x41, 0x21, 0x11, 0x09, 0x07, 0x00 // 7
#define data_ascii_8 0x36, 0x49, 0x49, 0x49, 0x36, 0x00 // 8
#define data_ascii_9 0x46, 0x49, 0x49, 0x29, 0x1E, 0x00 // 9

// all display array 
byte data_ascii[][display_array_size] = {
                       data_null,
                       data_null,
                       data_ascii_W,
                       data_ascii_W,
                       data_ascii_W,
                       data_ascii_dot,
                       data_ascii_K,
                       data_ascii_E,
                       data_ascii_Y,
                       data_ascii_E,
                       data_ascii_S,
                       data_ascii_Y,
                       data_ascii_dot,
                       data_ascii_A,
                       data_ascii_R,
                       data_ascii_D,
                       data_ascii_U,
                       data_ascii_I,
                       data_ascii_N,
                       data_ascii_0,
                       data_null,
                       data_ascii_F,
                       data_ascii_U,
                       data_ascii_N,
                       data_ascii_D,
                       data_ascii_U,
                       data_ascii_I,
                       data_ascii_N,
                       data_ascii_O,
                       data_null,
                       data_null,
                       data_ascii_L,
                       data_ascii_I,
                       data_ascii_S,
                       data_ascii_A,
                       data_ascii_colon,
                       data_null,
                       data_ascii_colon,
                       data_ascii_D,
                       data_ascii_E,
                       data_ascii_S,
                       data_ascii_I,
                       data_ascii_G,
                       data_ascii_N,
                       data_null,
                       data_ascii_L,
                       data_ascii_A,
                       data_ascii_I,
                       data_ascii_H,
                       data_ascii_O,
                       data_ascii_Y,
                       data_ascii_A,
                       data_null,
                       data_ascii_8,
                       data_ascii_8,
                       data_ascii_6,
                       data_ascii_minus,
                       data_ascii_4,
                       data_ascii_minus,
                       data_ascii_2,
                       data_ascii_2,
                       data_ascii_3,
                       data_ascii_9,
                       data_ascii_9,
                       data_ascii_1,
                       data_ascii_0,
                       data_ascii_0,
                       data_null,
                       data_null,
                       }; 

// Pin connected to ST_CP of 74HC595 for scanning
int scan_latch_pin = 5; // 白
// Pin connected to SH_CP of 74HC595 for scanning
int scan_clock_pin = 6; // 藍
// Pin connected to DS of 74HC595 for scanning
int scan_data_pin = 7; // 棕


void setup() {
  //set pins to output because they are addressed in the main loop
  pinMode(scan_latch_pin, OUTPUT);
  pinMode(scan_clock_pin, OUTPUT);
  pinMode(scan_data_pin, OUTPUT);
  Serial.begin(9600);
  
  // if the led matrix data sheets are different.
  /* 
   * for (int i = 0; i < display_array_size; i++)
   *   data_ascii[0][i] ^= 0xFF;  
   */
}

void loop() {
  // every 8 lines compose a word, 8 bits compose a line.
  // In order to avoid the back of LED have no information.
  for (int i = 1; i < (display_array_size - led_matrix_number * 8); i++ )
    display_led_from(i,25);
}

// 
void display_led_from(int index, int continue_time)
{
  //refresh times
  for (int k = 0; k < continue_time; k++)
  {
    // every LED dot matrix has 8 scan line
    for (int j = index; j < (index + 8); j++) {
      //ground scan_latch_pin and hold low for as long as you are transmitting
      digitalWrite(scan_latch_pin, LOW);
      
      //transmitting the data of LED Matrix1
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, byte((1 << (j-index)) ^ 0xFF));      
      //shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int(1 << (j-index)));
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int(data_ascii[0][j] ));
      
      //transmitting the data of LED Matrix2
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, byte((1 << (j-index)) ^ 0xFF));      
      //shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int(1 << (j-index)));
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int(data_ascii[0][j+8] ));
      
      //transmitting the data of LED Matrix3
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, byte((1 << (j-index)) ^ 0xFF));      
      //shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int(1 << (j-index)));
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int(data_ascii[0][j+16] ));
      
      //transmitting the data of LED Matrix4      
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, byte((1 << (j-index)) ^ 0xFF));
      //shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int( (1 << (j-index)) ) );
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int(data_ascii[0][j+24] ));
      
      //transmitting the data of LED Matrix5      
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, byte((1 << (j-index)) ^ 0xFF));
      //shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int( (1 << (j-index)) ) );
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int(data_ascii[0][j+32] ));
      
      //transmitting the data of LED Matrix6      
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, byte((1 << (j-index)) ^ 0xFF));
      //shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int( (1 << (j-index)) ) );
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int(data_ascii[0][j+40] ));
      
      //transmitting the data of LED Matrix7      
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, byte((1 << (j-index)) ^ 0xFF));
      //shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int( (1 << (j-index)) ) );
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int(data_ascii[0][j+48] ));
      
      //transmitting the data of LED Matrix8      
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, byte((1 << (j-index)) ^ 0xFF));
      //shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int( (1 << (j-index)) ) );
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int(data_ascii[0][j+56] ));
      
      //transmitting the data of LED Matrix9      
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, byte((1 << (j-index)) ^ 0xFF));
      //shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int( (1 << (j-index)) ) );
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int(data_ascii[0][j+64] ));
       
      //transmitting the data of LED Matrix10      
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, byte((1 << (j-index)) ^ 0xFF));
      //shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int( (1 << (j-index)) ) );
      shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, int(data_ascii[0][j+72] ));
       
      //return the latch pin high to signal chip that it 
      //no longer needs to listen for information
      digitalWrite(scan_latch_pin, HIGH);
      //Serial.print(1 << j-index, HEX);
      //Serial.print(" = ");
      //Serial.println(data_ascii[0][j], HEX);u
      //delay(1000);
    }
  }
}

void scan_line()
{
  //count up routine
  for (int j = 1; j <= 256; j <<= 1) 
  {
    //ground scan_latch_pin and hold low for as long as you are transmitting
    digitalWrite(scan_latch_pin, LOW);
    shiftOut(scan_data_pin, scan_clock_pin, MSBFIRST, j);   
    //return the latch pin high to signal chip that it 
    //no longer needs to listen for information
    digitalWrite(scan_latch_pin, HIGH);
    delay(500);
  }
}


